<?php

namespace Teknisa\CADFIN\Controllers;


use Teknisa\CADFIN\Controllers\TeknisaCrud;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\CADFIN\Services\Pag41100ContaPagarService;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;

class Pag41100ContaPagar extends TeknisaCrud{
    protected $dataSourceName = 'tipoctpagar_classfinanc_histpadr';
    
    public function __construct($crudService, ParameterBag $parameterBag, Pag41100ContaPagarService $pag41100ContaPagarService, EntityManager $entityManager) {
        $this->pag41100ContaPagarService = $pag41100ContaPagarService;
        $this->entityManager    = $entityManager;
        parent::__construct($crudService, $parameterBag);
    }
    
    public function getNvMaxContctbl(DTO\Request $request, DTO\Response $response) {
        $result = $this->pag41100ContaPagarService->getNvMaxContctbl();
        $dataSet = new DataSet('paramgeral', $result);
        $response->addDataSet($dataSet);
    }
    
    public function saveEmpresa(DTO\Request $request, DTO\Response $response) {
        try {
            $connection = $this->entityManager->getConnection();
            $connection->beginTransaction();
                
            $row        = $request->getRow();
            $this->pag41100ContaPagarService->saveEmpresa($row);
            
            $this->entityManager->commit();
            
        } catch (\Exception $e) {
            $this->entityManager->rollback();
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
        
    }
      
    public function cadastroAutomaticoEmpresa(DTO\Request $request, DTO\Response $response) {
        try {
            $connection = $this->entityManager->getConnection();
            $connection->beginTransaction();
                
            $row        = $request->getRow();
            $this->pag41100ContaPagarService->cadastroAutomaticoEmpresa($row);
            
            $this->entityManager->commit();
            
        } catch (\Exception $e) {
            $this->entityManager->rollback();
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
        
    }
  
}